#include "stdafx.h"

#include "StringStackDocument.h"

namespace dotNet {

StringStackDocument::StringStackDocument() {
  container_ = gcnew System::Collections::Generic::List<System::String^>();
}

void StringStackDocument::Push(System::String^ element) {
  container_->Add(element);
  handler_(this, nullptr);
}

System::String^ StringStackDocument::Pop() {
  System::String^ result = container_[container_->Count - 1];
  container_->RemoveAt(container_->Count -1);
  handler_(this, nullptr);
  return result;
}

void StringStackDocument::Clear() {
  container_->Clear();
  handler_(this, nullptr);
}

bool StringStackDocument::Empty() {
  return container_->Count == 0;
}

int  StringStackDocument::Size() {
  return container_->Count;
}

System::String^ StringStackDocument::At(int index) {
  return container_[index];
}

void StringStackDocument::AddObserver(System::EventHandler^ handler) {
  handler_ += handler;
}

void StringStackDocument::RemoveObserver(System::EventHandler^ handler) {
  handler_ -= handler;
}

}
